
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import java.io
import java.util
import org.hipparchus.geometry
import org.hipparchus.geometry.partitioning
import typing



_ConvexHull__S = typing.TypeVar('_ConvexHull__S', bound=org.hipparchus.geometry.Space)  # <S>
_ConvexHull__P = typing.TypeVar('_ConvexHull__P', bound=org.hipparchus.geometry.Point)  # <P>
class ConvexHull(java.io.Serializable, typing.Generic[_ConvexHull__S, _ConvexHull__P]):
    """
    public interfaceConvexHull<S extends :class:`~org.hipparchus.geometry.Space`,P extends :class:`~org.hipparchus.geometry.Point`<S>>extends :class:`~org.hipparchus.geometry.hull.https:.docs.oracle.com.javase.8.docs.api.java.io.Serializable`
    
        This class represents a convex hull.
    """
    def createRegion(self) -> org.hipparchus.geometry.partitioning.Region[_ConvexHull__S]: ...
    def getVertices(self) -> typing.MutableSequence[_ConvexHull__P]:
        """
            Get the vertices of the convex hull.
        
            Returns:
                vertices of the convex hull
        
        
        """
        ...

_ConvexHullGenerator__S = typing.TypeVar('_ConvexHullGenerator__S', bound=org.hipparchus.geometry.Space)  # <S>
_ConvexHullGenerator__P = typing.TypeVar('_ConvexHullGenerator__P', bound=org.hipparchus.geometry.Point)  # <P>
class ConvexHullGenerator(typing.Generic[_ConvexHullGenerator__S, _ConvexHullGenerator__P]):
    """
    public interfaceConvexHullGenerator<S extends :class:`~org.hipparchus.geometry.Space`,P extends :class:`~org.hipparchus.geometry.Point`<S>>
    
        Interface for convex hull generators.
    
        Also see:
    
              - `Convex Hull (Wikipedia) <http://en.wikipedia.org/wiki/Convex_hull>`
              - `Convex Hull (MathWorld) <http://mathworld.wolfram.com/ConvexHull.html>`
    """
    def generate(self, collection: typing.Union[java.util.Collection[_ConvexHullGenerator__P], typing.Sequence[_ConvexHullGenerator__P], typing.Set[_ConvexHullGenerator__P]]) -> ConvexHull[_ConvexHullGenerator__S, _ConvexHullGenerator__P]: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("org.hipparchus.geometry.hull")``.

    ConvexHull: typing.Type[ConvexHull]
    ConvexHullGenerator: typing.Type[ConvexHullGenerator]
